//
//  INKCachedImageManager.h
//  Net Kit Sample
//
//  Created by iTech on 24.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface INKCachedImageManager : NSObject {
    NSMutableDictionary *_imagesInfo;
    
    UIImage *_defaultImage;
    
    
}
// Image that returns if no image for key finded. 'nil' by default.
@property (nonatomic, retain) UIImage *defaultImage;

- (NSArray*)images;
- (NSArray*)keys;
- (NSDictionary*)imagesInfo;
- (NSInteger)imagesCount;

// Add image to cache manager. If image already exist then replace image with new image.
// Return YES if image was added.
- (BOOL)addImage:(UIImage*)image withKey:(NSString*)key;

// Add image to cache manager. Pass 'YES' in replace parameter to replace image with the same key.
// Return YES if image was added.
- (BOOL)addImage:(UIImage*)image withKey:(NSString*)key replace:(BOOL)replace;

// Add group of image for keys. Replace images with the same keys.
- (BOOL)addImages:(NSArray*)images forKeys:(NSArray*)keys;

// Remove image with the same key.
// Return NO if no image with the same key
- (BOOL)removeImage:(UIImage*)image withKey:(NSString*)key;

// Get image for key. If no image finded return default image ('nil' by default).
- (UIImage*)imageForKey:(NSString*)key;

// Return keys for NULL images;
- (NSArray*)keysWithNULLImage;

// Remove all images
- (void)clearCache;

@end
