//
//  INKURLRequest+HTTPHeaderFieldsExecutor.h
//  Net Kit Sample
//
//  Created by iTech on 23.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "INKURLRequest.h"


// HTTP Header fields list corresponds to the RFC 4229, RFC 1945, RFC 2068, RFC 2616, RFC 2617, RFC 1965, FRC 1806, FRC 2045

// General Headers.
// General headers are main for client and server requests. Most of them are required.

extern NSString * const HTTPHeaderFieldCacheControl;
extern NSString * const HTTPHeaderFieldConnection;
extern NSString * const HTTPHeaderFieldDate;
extern NSString * const HTTPHeaderFieldMIMEVersion;
extern NSString * const HTTPHeaderFieldPragma;
extern NSString * const HTTPHeaderFieldTrailer;
extern NSString * const HTTPHeaderFieldTransferEncoding;
extern NSString * const HTTPHeaderFieldUpgrade;
extern NSString * const HTTPHeaderFieldVia;
extern NSString * const HTTPHeaderFieldWarning;


// Other headers

// Accept
extern NSString * const HTTPHeaderFieldAccept;
extern NSString * const HTTPHeaderFieldAcceptCharset;
extern NSString * const HTTPHeaderFieldAcceptEncoding;
extern NSString * const HTTPHeaderFieldAcceptLanguage;
extern NSString * const HTTPHeaderFieldAcceptRanges;
extern NSString * const HTTPHeaderFieldAge;
extern NSString * const HTTPHeaderFieldAllow;
extern NSString * const HTTPHeaderFieldAlternates;
extern NSString * const HTTPHeaderFieldAuthorization;
extern NSString * const HTTPHeaderFieldCacheControl;
extern NSString * const HTTPHeaderFieldConnection;

// Content
extern NSString * const HTTPHeaderFieldContentBase;         // Deprecated since HTTP/1.1v2.
extern NSString * const HTTPHeaderFieldContentDisposition;
extern NSString * const HTTPHeaderFieldContentEncoding;
extern NSString * const HTTPHeaderFieldContentLanguage;
extern NSString * const HTTPHeaderFieldContentLength;
extern NSString * const HTTPHeaderFieldContentLocation;
extern NSString * const HTTPHeaderFieldContentMD5;
extern NSString * const HTTPHeaderFieldContentRange;
extern NSString * const HTTPHeaderFieldContentType;
extern NSString * const HTTPHeaderFieldContentVersion;

extern NSString * const HTTPHeaderFieldDate;
extern NSString * const HTTPHeaderFieldDerivedFrom;
extern NSString * const HTTPHeaderFieldETag;
extern NSString * const HTTPHeaderFieldExpect;
extern NSString * const HTTPHeaderFieldExpires;
extern NSString * const HTTPHeaderFieldFrom;
extern NSString * const HTTPHeaderFieldHost;

extern NSString * const HTTPHeaderFieldIfMatch;
extern NSString * const HTTPHeaderFieldIfModifiedSince;
extern NSString * const HTTPHeaderFieldIfNoneMatch;
extern NSString * const HTTPHeaderFieldIfRange;
extern NSString * const HTTPHeaderFieldIfUnmodifiedSince;

extern NSString * const HTTPHeaderFieldLastModified;
extern NSString * const HTTPHeaderFieldLink;
extern NSString * const HTTPHeaderFieldLocation;
extern NSString * const HTTPHeaderFieldMaxForwards;

extern NSString * const HTTPHeaderFieldProxyAuthenticate;
extern NSString * const HTTPHeaderFieldProxyAuthorization;
extern NSString * const HTTPHeaderFieldPublic;
extern NSString * const HTTPHeaderFieldRange;
extern NSString * const HTTPHeaderFieldReferer;
extern NSString * const HTTPHeaderFieldRetryAfter;
extern NSString * const HTTPHeaderFieldServer;
extern NSString * const HTTPHeaderFieldTitle;
extern NSString * const HTTPHeaderFieldTE;
extern NSString * const HTTPHeaderFieldURI;             // Deprecated since HTTP/1.1. Use Location, Content-Location, Vary and Link instead.
extern NSString * const HTTPHeaderFieldUserAgent;
extern NSString * const HTTPHeaderFieldVary;
extern NSString * const HTTPHeaderFieldWWWAuthenticate;

@interface INKURLRequest (HTTPHeaderFieldsExecutor)

// HTTP header fields that must be in every request (no matter incoming or outcoming)
+ (NSArray*)generalHTTPHeaderFields;

+ (NSArray*)requestHTTPHeaderFields;

// Values for general HTTP header fields
- (NSDictionary*)generalHTTPHeaderFieldsValues;

@end
