//
//  INKURLRequest+HTTPHeaderFieldsExecutor.m
//  Net Kit Sample
//
//  Created by iTech on 23.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "INKURLRequest+HTTPHeaderFieldsExecutor.h"

NSString * const HTTPHeaderFieldCacheControl = @"Cache-Control";
NSString * const HTTPHeaderFieldConnection = @"Connection";
NSString * const HTTPHeaderFieldDate = @"Date";
NSString * const HTTPHeaderFieldMIMEVersion = @"MIME-Version";
NSString * const HTTPHeaderFieldPragma = @"Pragma";
NSString * const HTTPHeaderFieldTrailer = @"Trailer";
NSString * const HTTPHeaderFieldTransferEncoding = @"Transfer-Encoding";
NSString * const HTTPHeaderFieldUpgrade = @"Upgrade";
NSString * const HTTPHeaderFieldVia = @"Via";
NSString * const HTTPHeaderFieldWarning = @"Warning";

NSString * const HTTPHeaderFieldAccept = @"Accept";
NSString * const HTTPHeaderFieldAcceptCharset = @"Accept-Charset";
NSString * const HTTPHeaderFieldAcceptEncoding = @"Accept-Encoding";
NSString * const HTTPHeaderFieldAcceptLanguage = @"Accept-Language";
NSString * const HTTPHeaderFieldAcceptRanges = @"Accept-Ranges";
NSString * const HTTPHeaderFieldAge = @"Age";
NSString * const HTTPHeaderFieldAllow = @"Allow";
NSString * const HTTPHeaderFieldAlternates = @"Alternates";
NSString * const HTTPHeaderFieldAuthorization = @"Authorization";

NSString * const HTTPHeaderFieldContentBase = @"Content-Base";
NSString * const HTTPHeaderFieldContentDisposition = @"Content-Disposition";
NSString * const HTTPHeaderFieldContentEncoding = @"Content-Encoding";
NSString * const HTTPHeaderFieldContentLanguage = @"Content-Language";
NSString * const HTTPHeaderFieldContentLength = @"Content-Length";
NSString * const HTTPHeaderFieldContentLocation = @"Content-Location";
NSString * const HTTPHeaderFieldContentMD5 = @"Content-MD5";
NSString * const HTTPHeaderFieldContentRange = @"Content-Range";
NSString * const HTTPHeaderFieldContentType = @"Content-Type";
NSString * const HTTPHeaderFieldContentVersion = @"Content-Version";

NSString * const HTTPHeaderFieldDerivedFrom = @"Derived-From";
NSString * const HTTPHeaderFieldETag = @"ETag";
NSString * const HTTPHeaderFieldExpect = @"Expect";
NSString * const HTTPHeaderFieldExpires = @"Expires";
NSString * const HTTPHeaderFieldFrom = @"From";
NSString * const HTTPHeaderFieldHost = @"Host";

NSString * const HTTPHeaderFieldIfMatch = @"If-Match";
NSString * const HTTPHeaderFieldIfModifiedSince = @"If-Modified-Since";
NSString * const HTTPHeaderFieldIfNoneMatch = @"If-None-Match";
NSString * const HTTPHeaderFieldIfRange = @"If-Range";
NSString * const HTTPHeaderFieldIfUnmodifiedSince = @"If-Unmodified-Since";

NSString * const HTTPHeaderFieldLastModified = @"Last-Modified";
NSString * const HTTPHeaderFieldLink = @"Link";
NSString * const HTTPHeaderFieldLocation = @"Location";
NSString * const HTTPHeaderFieldMaxForwards = @"Max-Forwards";

NSString * const HTTPHeaderFieldProxyAuthenticate = @"Proxy-Authenticate";
NSString * const HTTPHeaderFieldProxyAuthorization = @"Proxy-Authorization";
NSString * const HTTPHeaderFieldPublic = @"Public";
NSString * const HTTPHeaderFieldRange = @"Range";
NSString * const HTTPHeaderFieldReferer = @"Referer";
NSString * const HTTPHeaderFieldRetryAfter = @"Retry-After";
NSString * const HTTPHeaderFieldServer = @"Server";
NSString * const HTTPHeaderFieldTitle = @"Title";
NSString * const HTTPHeaderFieldTE = @"TE";
NSString * const HTTPHeaderFieldURI = @"URI";
NSString * const HTTPHeaderFieldUserAgent = @"User-Agent";
NSString * const HTTPHeaderFieldVary = @"Vary";
NSString * const HTTPHeaderFieldWWWAuthenticate = @"WWW-Authenticate";

@implementation INKURLRequest (HTTPHeaderFieldsExecutor)
- (NSDictionary*)generalHTTPHeaderFieldsValues {
    NSArray *keys = [INKURLRequest generalHTTPHeaderFields];
    NSDictionary *values = [self responseHTTPHeaderFields];
    return [values dictionaryWithValuesForKeys:keys];
}

+ (NSArray*)generalHTTPHeaderFields {
    return [NSArray arrayWithObjects:
            HTTPHeaderFieldCacheControl,
            HTTPHeaderFieldConnection,
            HTTPHeaderFieldDate,
            HTTPHeaderFieldMIMEVersion,
            HTTPHeaderFieldPragma,
            HTTPHeaderFieldTrailer,
            HTTPHeaderFieldTransferEncoding,
            HTTPHeaderFieldUpgrade,
            HTTPHeaderFieldVia,
            HTTPHeaderFieldWarning,
            nil];
}

+ (NSArray*)requestHTTPHeaderFields {
    return [NSArray arrayWithObjects:
            HTTPHeaderFieldAccept,
            HTTPHeaderFieldAcceptCharset,
            HTTPHeaderFieldAcceptEncoding,
            HTTPHeaderFieldAcceptLanguage,
            HTTPHeaderFieldAuthorization,
            HTTPHeaderFieldContentDisposition,
            HTTPHeaderFieldExpect,
            HTTPHeaderFieldFrom, 
            HTTPHeaderFieldHost,
            HTTPHeaderFieldIfMatch,
            HTTPHeaderFieldIfModifiedSince,
            HTTPHeaderFieldIfNoneMatch,
            HTTPHeaderFieldIfRange,
            HTTPHeaderFieldIfUnmodifiedSince,
            HTTPHeaderFieldMaxForwards,
            HTTPHeaderFieldProxyAuthorization,
            HTTPHeaderFieldRange,
            HTTPHeaderFieldReferer,
            HTTPHeaderFieldTE,
            HTTPHeaderFieldUserAgent,
            nil];
}



@end
