//
//  INKURLRequest.h
//  Net Kit Sample
//
//  Created by Vladlex on 22.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "INKHelper.h"

@interface INKURLRequest : NSMutableURLRequest {
    INKURLRequestOperationBlock _requestOperationBlock;
    NSDictionary *_userInfo;
    NSMutableData *_incomingData;
    NSURLResponse *_response;
    NSError *_connectionError;
    
    NSNumber *_sendedLastPacketBytes;
    NSNumber *_totalBytesSended;
    NSNumber *_totalBytesExpectedToWrite;
}

// This block should be automatically called by requests manager after loading.
// If you use NSURLConnection to load this request than requestCompletionBlock not been called
@property (nonatomic, copy) INKURLRequestOperationBlock requestOperationBlock;

// Connection error save to this variable
@property (nonatomic, retain) NSError *connectionError;

// Server response save to this variable
@property (nonatomic, retain) NSURLResponse *response;

// You can pass any information in this dictionary
@property (nonatomic, retain) NSDictionary *userInfo;

// Incoming data save to this variable
@property (nonatomic, retain) NSMutableData *incomingData;

@property (nonatomic, retain) NSNumber *sendedLastPacketBytes, *totalBytesSended, *totalBytesExpectedToWrite;

// Returns currend downloading progress. 
// The value is a floating-point number in the range 0.0 to 1.0.
- (float)downloadProgress;

// Perform completion block
- (void)performBlockWithCompletion:(BOOL)completion cause:(INKURLRequestOperationBlockCause)cause;

// Returns HTTP header fields of current request.
- (NSDictionary*)responseHTTPHeaderFields;

// Set the method for request. 
- (void)setMethod:(INKURLRequestMethodType)method;

// Copy request from NSURLRequest
+ (id)inkRequestCopy:(NSURLRequest*)request;

@end
