//
//  INKViewController.m
//  Net Kit Sample
//
//  Created by Vladlex on 22.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ITCHMainViewController.h"

#import "ITCHHTTPHeaderFieldsViewController.h"
#import "ITCHManySmallImagesViewController.h"
#import "ITCHBigImagesViewController.h"

#import "INKURLRequest+HTTPHeaderFieldsExecutor.h"
#import "INKURLConnection.h"


@interface ITCHMainViewController ()
- (void)configureCell:(UITableViewCell*)cell atIndexPath:(NSIndexPath*)indexPath;
@end

@implementation ITCHMainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        
    }
    return self;
}

- (void)dealloc {
    [_tableView release];
    [super dealloc];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    self.title = @"iTech Net Kit Sample";
    
    _tableView = [[UITableView alloc] initWithFrame:self.view.bounds style:UITableViewStyleGrouped];
    _tableView.autoresizingMask = (UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth);
    _tableView.contentInset = UIEdgeInsetsMake(0.0, 0.0, 0.0, 0.0);
    _tableView.dataSource = self;
    _tableView.delegate = self;
    _tableView.rowHeight = 57.0;
    

    [self.view addSubview:_tableView];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

#pragma mark Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 3;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 1;
}

- (NSString*)tableView:(UITableView *)tableView titleForFooterInSection:(NSInteger)section {
    switch (section) {
        case 0:
           return @"Send request to get response http header fields."; 
            break;
        case 1:
            return @"Loading 10 small (square, 50 px, noised) images asyncronous. Maximum downloaded images = 5 (by default).";
            break;
        case 2:
            return @"Loading big (square,  640 px, noised) images asyncronous. Show the progress for loading images (2 maximum) and activity indicator for waiting in queue.";
            break;
        default:
            break;
    }
    return @"";
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellIdentifier = @"Cell";

    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:cellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellIdentifier] autorelease];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    [self configureCell:cell atIndexPath:indexPath];
    return cell;
}

- (void)configureCell:(UITableViewCell *)cell atIndexPath:(NSIndexPath *)indexPath {
    switch (indexPath.section) {
        case 0:
            cell.textLabel.text = @"Check HTTP Header fields";
            break;
        case 1:
            cell.textLabel.text = @"Check small images loading";
            break;
        case 2:
            cell.textLabel.text = @"Check big image loading";
            break;
        default:
            cell.textLabel.text = @"";
            break;
    }
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    UIViewController *pushedController = nil;
    switch (indexPath.section) {
        case 0:
            pushedController = [[[ITCHHTTPHeaderFieldsViewController alloc] init] autorelease];
            break;
        case 1:
            pushedController = [[[ITCHManySmallImagesViewController alloc] init] autorelease];
            break;
        case 2:
            pushedController = [[[ITCHBigImagesViewController alloc] init] autorelease];
            break;
        default:

            break;
    }
    if (pushedController) {
        [self.navigationController pushViewController:pushedController animated:YES];
    }
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
}

@end
